"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasDefinitelyTyped = void 0;

var _core = require("@yarnpkg/core");

var _algoliasearch = _interopRequireDefault(require("algoliasearch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Note that the appId and appKey are specific to Yarn's plugin-typescript - please
// don't use them anywhere else without asking Algolia's permission
const ALGOLIA_API_KEY = 'e8e1bd300d860104bb8c58453ffa1eb4';
const ALGOLIA_APP_ID = 'OFCNCOG2CU';

const hasDefinitelyTyped = async (descriptor, configuration) => {
  const stringifiedIdent = _core.structUtils.stringifyIdent(descriptor);

  const algoliaClient = createAlgoliaClient(configuration);
  const index = algoliaClient.initIndex('npm-search');

  try {
    var _packageInfo$types;

    const packageInfo = await index.getObject(stringifiedIdent, {
      attributesToRetrieve: ['types']
    });
    return ((_packageInfo$types = packageInfo.types) === null || _packageInfo$types === void 0 ? void 0 : _packageInfo$types.ts) === 'definitely-typed';
  } catch (_e) {
    return false;
  }
};

exports.hasDefinitelyTyped = hasDefinitelyTyped;

const createAlgoliaClient = configuration => {
  const requester = {
    async send(request) {
      try {
        const response = await _core.httpUtils.request(request.url, request.data || null, {
          configuration,
          headers: request.headers
        });
        return {
          content: response.body,
          isTimedOut: false,
          status: response.statusCode
        };
      } catch (error) {
        return {
          content: error.response.body,
          isTimedOut: false,
          status: error.response.statusCode
        };
      }
    }

  };
  return (0, _algoliasearch.default)(ALGOLIA_APP_ID, ALGOLIA_API_KEY, {
    requester
  });
};